//Note: The type code is the four letter code displayed by Resourcer
//      with single quotation marks around it.
//      For instance, CSTR would be written as 'CSTR'


#include <storage/Resources.h>
#include <support/DataIO.h>

const void *AppResource(type_code type,int32 id,size_t *lengthFound); //-Returns indicated resource, places length in lengthFound
const void *AppResource(type_code type,const char *name,size_t *lengthFound); //-Returns indicated resource, places length in lengthFound

class ResourceIO : public BPositionIO { //----------Implements BPositionIO protocol for resources
	public:
		ResourceIO(type_code type,int32 id); //---------Constructs a new object for resource at id of type
		ResourceIO(type_code type,const char *name); //-Constructs a new object for resource named name of type
		ssize_t Read(void *buffer,size_t numBytes); //--Read reasource info buffer from current position on for numBytes
		ssize_t ReadAt(off_t position,void *buffer,size_t numBytes); //-Reads resource into buffer from position on for numBytes
		off_t Seek(off_t position,uint32 mode); //------Seek, see BPositionIO
		off_t Position(void) const;		//--------------Current position
		ssize_t Write(const void *buffer,size_t numBytes); //-Writes buffer of length numBytes into resource at current position
		ssize_t WriteAt(off_t position,const void *buffer,size_t numBytes);	//-Writes buffer of length numBytes at position
		size_t Size(void);				//--------------Gets size of resource
		status_t SetSize(off_t size);	//--------------Returns B_ERROR
		int32 ID(void);					//--------------ID of resource
		~ResourceIO(void)				//--------------Deallocates name
	private:
		int32 id;
		type_code type;
		off_t curPos;
		char *name;
		BResources *res;
};



/*--------------------------------FOR COMPATIBILITY ONLY-------------------------------------------*/
/**/status_t get_app_resource(type_code type,const char *name,void** buffer,size_t *lengthFound);/**/
/**/status_t get_app_resource(type_code type,long id,void** buffer,size_t *lengthFound);/*---------*/
/*-------------------------------------------------------------------------------------------------*/