// extracts a BBitmap from a Resource

//IMPORTANT!
//Requires libtranslation.so

#include <translation/TranslationUtils.h>
#include <interface/Bitmap.h>
#include <interface/View.h>

BBitmap *get_bitmap(long id);
BBitmap *get_bitmap(const char *name);

class _EXPORT ResImageView : public BView {
	public:
		ResImageView(BResources *res = be_app->AppResources());
		ResImageView(BRect rect,int32 id,char *viewname,BResources *res = be_app->AppResources());
		ResImageView(BRect rect,char *name,BResources *res = be_app->AppResources());
		ResImageView(BMessage *archive);
		void SetTo(int32 id,bool changesize = true);
		void SetTo(char *name,bool changesize = true);
		void Draw(BRect area);
		virtual	status_t	Archive(BMessage *into, bool deep = true) const;
		static	BArchivable	*Instantiate(BMessage *from);
		int32 ResourceID(void);
		~ResImageVIew(void);
	private:
		BBitmap *bitmap;
		int32 resid;
		BResources *res;
};